package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.mapping.*;
import com.hartmath.lib.*;


public class EASinh extends E1Arg
{
/*
//ASinh:
ASinh(0)=0;
ASinh(I)=1/2*I*Pi;
ASinh(Infinity)=Infinity;
ASinh(x_IsNumber):=Check(SignumCmp(x)<0, -ASinh(-x));
ASinh(x_IsNumber*y_):=Check(SignumCmp(x)<0, -ASinh(-x*y));
 */
   final static long larr[] =
   {6150318741426012165L,4707221958444449792L,-9167421934646976256L,9583700899537420L,2455959672098717696L,2453654812597763617L,72465278521866L
,5924856209907012159L,-4089795127716724793L,-1706211981536526254L,4558179535699137034L,5924856209907012159L,-4089795127716724910L
};

   final static byte barr[] =
   {63, -57, -24, -25, };
  
   static boolean first = true;
   public EASinh()
   {
     if (first) {
        first = false;
        C.EV( InitRules.init(larr, barr) );
     }
   }

   public HObject e1DblArg(HDouble dbl)
   {
     return dbl.asinh();
   }
   public HObject e1DblComArg(HDoubleComplex d)
   {
     return d.asinh();
   }

}




