package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EArray implements FunctionEvaluator
{
   public EArray()
   {
   }
   /**
    * Method declaration
    *
    *
    * @param vect
    *
    * @return
    *
    * @see
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 2)
      {
         if (vect.get(1) instanceof HInteger || vect.get(1) instanceof HDouble)
         {
            int m = 0;

            if (vect.get(1) instanceof HInteger)
            {
               m = ((HInteger) vect.get(1)).intValue();
            }
            else
            {
               m = ((HDouble) vect.get(1)).intValue();
            }

            HFunction   lst = new HFunction(C.List, m);
            HFunction   f;

            for (int i = 0; i < m; i++)
            {
               f = new HFunction(C.Null, HInteger.valueOf(i + 1));

               lst.set(i, f.apply(vect.get(0)));
            }

            return lst;
         }

         if (vect.get(1).isList()) {}
      }

      return null;
   }

}