/*--- formatted by Jindent 2.0b2, (www.c-lab.de/~jindent) ---*/

package com.hartmath.mapping;

import com.hartmath.expression.*;
import com.hartmath.lib.*;

/**
 * Evaluate predicate-functions with 1 argument
 * 
 * @see FunctionEvaluator
 * @see HSymbol
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public class EB1ObjectArg implements FunctionEvaluator {

	/**
	 * @param vect   vector of the function, which should be evaluated
	 * @return       <code>null</code> or the evaluated object
	 */
	public HObject evaluate(HFunction vect) {
		if (vect.size() == 1) {
			if (evalArg1(vect.get(0))) {
				return C.True;
			}

			return C.False;
		}

		return C.False;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @param o0
	 *
	 * @return
	 *
	 * @see
	 */
	public boolean evalArg1(HObject o0) {

		// try only on object level

		return false;
	}

}



/*--- formatting done in "Sun Java Convention" style on 06-18-1999 ---*/

