package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;
import com.hartmath.awt.*;

import com.hartmath.JSci.awt.*;

import java.applet.*;
import java.awt.*;

import java.awt.*;

public class EBarGraph implements FunctionEvaluator
{
    private BarGraph graph;
    private Frame f;
    public EBarGraph()
    {
    }
		public HObject evaluate(HFunction vect) {
      if (vect.size() <= 2 &&
          vect.get(0).isList() ) {
        HFunction lst0 = (HFunction) vect.get(0);
        if (lst0.size()==0)
        {
          return null;
        }
        float data[]=new float[lst0.size()];
        HObject a;
        for (int i=0;i<lst0.size();i++)
        {
          a = C.EV( C.N.f( lst0.get(i) ) );
          if (!(a instanceof HDouble)  ) {
            return null;
          }
          data[i]=((HDouble)a).floatValue();
        }

        f = new EFrame(true);
        DefaultCategoryGraph2DModel model=new DefaultCategoryGraph2DModel();  
       // model.setXAxis(data[0]);  
        model.addSeries(data);
        if (vect.size() == 2 &&
            vect.get(1).isList() ) {
          model.setCategories( ((HArrayList)vect.get(1)).toArray() );
        }
        graph=new BarGraph(model);  
     //   graph.setNumbering(true);  
        f.setLayout(new BorderLayout());  
        f.add(graph,"Center");  
        f.show();
      }
      return C.Null;
    }
}

