package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.mapping.*;
import com.hartmath.lib.*;

public class ECosh extends E1Arg
{
/*
//Cosh:
Cosh(x_IsNumber):=Check(SignumCmp(x)<0, Cosh(-x));
Cosh(x_IsNumber*y_):=Check(SignumCmp(x)<0, Cosh(-x*y));
Cosh(0)=1;
Cosh(Infinity)=Infinity;
Cosh(I)=Cos(1);
 */
   final static long larr[] =
   {6150318750333485544L,2535335319515517268L,-1673561093865224216L,5931611301879955944L,2535470867477051729L,6118358145200963410L,4595898024970899725L
,-4123799383172111859L,2453707872602497548L};

   final static byte barr[] =
   {81, 12, -59, };
  
   static boolean first = true;
   public ECosh()
   {
     if (first) {
        first = false;
        C.EV( InitRules.init(larr, barr) );
     }
   }

   public HObject e1DblArg(HDouble dbl)
   {
      return dbl.cosh();
   }
   public HObject e1DblComArg(HDoubleComplex d)
   {
     return d.cosh();
   }

}




