package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EDegreeP implements FunctionEvaluator {
    public EDegreeP()
    {
    }
		public HObject evaluate(HFunction vect) {
			if (vect.size() == 2) {
        HPolynomial poly = new HPolynomial(vect.get(0), vect.get(1));
        if (poly.size()==0) {
          return C.C0;
        }
        return HInteger.valueOf(poly.degree());
        /*
				HFunction	p = new HFunction(C.List);

				if (HFunction.polyList(vect.get(0), vect.get(1), p)) {
					if (p.size() == 0) {
						return C.C0;
					}

					return HInteger.valueOf(p.pDegree());
				} */
			}

			return null;
		}

}

