package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EDelete implements FunctionEvaluator
{
   public EDelete()
   {
   }
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 2 && vect.get(0) instanceof HFunction)
      {
         if (vect.get(1) instanceof HInteger || vect.get(1) instanceof HDouble)
         {
            int m = 0;

            if (vect.get(1) instanceof HInteger)
            {
               m = ((HInteger) vect.get(1)).intValue();
            }
            else
            {
               m = ((HDouble) vect.get(1)).intValue();
            }

            HFunction   f = (HFunction) ((HFunction) vect.get(0)).clone();

            f.remove(m - 1);

            return f;
         }
      }

      return null;
   }

}