package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EDiagonalMatrix implements FunctionEvaluator {
    public EDiagonalMatrix()
    {
    }
    public HObject evaluate(HFunction fun) {
        if ((fun.size() == 1) && (fun.get(0) instanceof HFunction)) {
            HFunction lst = (HFunction)fun.get(0);
            int m = lst.size();
            HFunction mat = new HFunction(C.List, C.List, m, m, HFunction.MATRIXFORM);
            for (int i = 0; i < m; i++) {
                for (int j = 0; j < m; j++) {
                    if (i == j) {
                        mat.set(i, j, lst.get(i));
                    }
                    else {
                        mat.set(i, j, C.C0);
                    }
                }
            }
            return mat;
        }
        return null;
    }
}

