package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EDimensions implements FunctionEvaluator
{
   public EDimensions()
   {
   }
   /**
    * Method declaration
    *
    *
    * @param fun
    *
    * @return
    *
    * @see
    */
   public HObject evaluate(HFunction fun)
   {
      if ((fun.size() == 1) && (fun.get(0) instanceof HFunction))
      {
         HFunction      lst = (HFunction) fun.get(0);
         int            m = lst.size();
         HFunction      res = C.List.f(HInteger.valueOf(m));
         HSymbol        header = lst.head();
         int            l = 0;

         for (int i = 0; i < m; i++)
         {
            if (!header.equals(lst.get(i).head()))
            {
               return res;
            }

            if (lst.get(i) instanceof HFunction)
            {
               if (i == 0)
               {
                  l = ((HFunction) lst.get(0)).size();
               }
               else
               {
                  if (l != ((HFunction) lst.get(i)).size())
                  {
                     return res;
                  }
               }
            }
            else
            {
               return res;
            }
         }

         res.add(HInteger.valueOf(l));

         return res;
      }

      return null;
   }

}
