/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

import org.kaffe.java.util.*;

import java.net.URL;
import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;

/**
 * Class Declaration.
 * 
 * 
 * @see
 * 
 * @author
 * @version   %I%, %G%
 */
public class EDo implements FunctionEvaluator
{
   public EDo()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() >= 2)
      {
         iterLoop(vect, 1);

         return C.Null;
      }

      return null;
   }

   /**
    * Method Declaration.
    * 
    * 
    * @param vect
    * @param index
    * 
    * @return
    * 
    * @see
    */
   public HObject iterLoop(HFunction vect, int index)
   {
      if (index < vect.size())
      {
         if (((HObject) vect.get(index)).isList())
         {
            HIterator   iter = new HIterator((HFunction) vect.get(index));

            index++;

            while (iter.hasMoreElements())
            {
               iterLoop(vect, index);
               iter.nextElement();
            }

            iter.clearVariable();
         }
      }
      else
      {
         C.EV(vect.get(0));
      }

      return null;
   }

}


