/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

import org.kaffe.java.util.*;

import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;

/**
 * Floating point functions with 1 argument of type HDouble or HDoubleComplex
 * 
 * @see FunctionEvaluator
 * 
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public class EErf extends E1Arg
{
/*
// Erf:
Erf(0)=0;
Erf(x_IsNumber):=Check(SignumCmp(x)<0, -Erf(-x));
Erf(x_IsNumber*y_):=Check(SignumCmp(x)<0, -Erf(-x*y));
*/
   final static long larr[] =
   {6006203553350156291L,5004174286148108486L,-4156170178826076095L,-1719478603318412975L,6118358150342458913L,90433890308689L,4476859505962861032L
    ,2535470867477051729L,6118358150342458913L,90431916328936L};


   final static byte barr[] =
   {-25, };
  
   static boolean first = true;
   public EErf()
   {
     if (first) {
        first = false;
        C.EV( InitRules.init(larr, barr) );
     }
   }
   public HObject e1DblArg(HDouble dbl)
   {
      return new HDouble(HDoubleSpecial.error(dbl.doubleValue()));
   }
}

