package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

import java.io.*;

public class EExec implements FunctionEvaluator
{

   public EExec()
   {
   }

   public HObject evaluate(HFunction f)
   {
      if (f.size() == 1 && f.get(0) instanceof HString)
      {
         Runtime        rt = Runtime.getRuntime();

         try
         {
            rt.exec(((HString) f.get(0)).toString());

            return C.Null;
         }
         catch (IOException me)
         {
            throw new HThrowException(C.Error, C.Exec);
         }
      }

      return null;
   }

}
