/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

import org.kaffe.java.util.*;

import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;

/**
 * Class Declaration.
 * @see
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 * @version   %I%, %G%
 */
public class EExpandAll extends EExpand {
    public EExpandAll()
    {
    }
    /**
     * Method Declaration.
     * @param f
     * @param sym
     * @return
     * @see
     */
    public HObject mapExpand(HFunction f) {
        return f.map(C.ExpandAll);
    }

    /**
     * Method Declaration.
     * @param f
     * @param i
     * @return
     * @see
     */
    public HObject multiplyMultiExpand(HFunction f, int i) {
        return multiplyExpand(f.get(i), C.ExpandAll.f(new HFunction(f, C.Multiply, i, i + 1, false)));
    }

    /**
     * Method Declaration.
     * @param o0
     * @param o1
     * @return
     * @see
     */
    public HObject multiplyExpand(HObject o0, HObject o1) {
        HObject temp;
        if (o0 instanceof HFunction) {
            HFunction f0 = (HFunction)o0;
            int lim0 = f0.size();
            if ((o1 instanceof HFunction) && (((HFunction)o1).head().equals(C.Multiply) ||
                ((HFunction)o1).head().equals(C.Add))) {
                HFunction f1 = (HFunction)o1;
                int lim1 = f1.size();
                if (f1.head().equals(C.Multiply)) {
                    HFunction m_expnd = new HFunction(C.Add, lim0);
                    HFunction f2;
                    for (int i = 0; i < lim0; i++) {
                        f2 = C.Multiply.f(f0.get(i));
                        for (int j = 0; j < lim1; j++) {
                            f2.add(f1.get(j));
                        }
                        m_expnd.set(i, C.ExpandAll.f(f2));
                    }
                    return m_expnd;
                }
                if (f1.head().equals(C.Add)) {
                    HFunction a_expnd = new HFunction(C.Add, lim0 * lim1);
                    for (int i = 0; i < lim0; i++) {
                        temp = f0.get(i);
                        for (int j = 0; j < lim1; j++) {
                            a_expnd.set(i * lim1 + j, C.ExpandAll.f(C.Multiply.f(temp, f1.get(j))));
                        }
                    }
                    return a_expnd;
                }
            }
            else {
                HFunction expnd = new HFunction(C.Add, lim0);
                for (int i = 0; i < lim0; i++) {
                    expnd.set(i, C.ExpandAll.f(C.Multiply.f(f0.get(i), o1)));
                }
                return expnd;
            }
        }
        return null;
    }
}

