package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

/**
 * Fatorial2 numbers n*(n-2)*(n-4)...
 */
public class EFactorial2 extends E1Arg {
    public EFactorial2()
    {
    }
		public HObject e1IntArg(HInteger fac) {
			if (fac.isLess(C.C3)) {
				if (fac.isGreater(C.C1)) {
					return C.C2;
				}

				return C.C1;
			}
			if (fac.isLess(C.C0)) {
				return null;
			}

			HInteger res = C.C1;

			for (HInteger i = fac; i.isGreaterEqual(C.C2); 
					  i = i.subtract(C.C2)) {
				res = res.multiply(i);
			}

			return res;
		}

	}

