package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

/**
 * Fibonacci numbers
 */
public class EFibonacci extends E1Arg {
    public EFibonacci()
    {
    }
		public HObject e1ObjArg(HObject o) {
			if (C.IsNegative.f(o).equals(C.True)) {
				return C.C0;
			}
			if (o instanceof HInteger) {
				HInteger a = C.C1;
				HInteger b = C.C0;
				HInteger c = C.C1;
				HInteger d = C.C0;
				HInteger f = C.C0;
				HInteger temp = (HInteger) o;

				while (temp.isNonZero()) {
					if (temp.isOdd()) {
						d = f.multiply(c);
						f = a.multiply(c).add(f.multiply(b).add(d));
						a = a.multiply(b).add(d);
					}

					d = c.multiply(c);
					c = b.multiply(c).multiply(C.C2).add(d);
					b = b.multiply(b).add(d);
					temp = temp.shiftRight(1);		// temp /= 2;
				}											// end while

				return f;
			}

			return null;
		}

	}
