package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

/**
 * Class declaration
 *
 *
 * @author
 * @version %I%, %G%
 */
public class EFixedPoint implements FunctionEvaluator
{
   public EFixedPoint()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 2)
      {
         HObject        temp;
         HObject        result = vect.get(1);

         do
         {
            temp = result;
            result = C.EV(temp.apply(vect.get(0)));
         }
         while (!result.equals(temp));

         return result;
      }

      return null;
   }

}
