package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EFor implements FunctionEvaluator
{
   public EFor()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 4)
      {
         C.EV(vect.get(0));

         while (C.EV(vect.get(1)) == C.True)
         {
            try
            {
               C.EV(vect.get(3));
            }
            catch (HBreakException e)
            {
               return C.Null;
            }
            catch (HContinueException e) {}

            C.EV(vect.get(2));
         }
      }

      return C.Null;
   }

}