package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EFullForm implements FunctionEvaluator
{
   public EFullForm()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 1)
      {
         StringBuffer   buf = new StringBuffer();

         buf.append("internal form:");

         if (vect.get(0) instanceof HFunction)
         {
            buf.append(((HFunction) vect.get(0)).toFullForm());
         }
         else
         {
            buf.append(vect.get(0).toString());
         }

         return new HString(buf);
      }

      return null;
   }

}
