package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EGCDP implements FunctionEvaluator {
    public EGCDP()
    {
    }
    public HObject evaluate(HFunction vect) {
			if (vect.size() == 3) {
        HPolynomial p = new HPolynomial(vect.get(0), vect.get(2));
        HPolynomial q = new HPolynomial(vect.get(1), vect.get(2));
 			  if (q.isNull()) {
					return null;
				}
        p = p.gcd(q);
        p.reduce(true);
   			return p.toFunction( );
			}

			return null;
		}                     

}
