package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EIsComplex extends EB1ObjectArg {
   public EIsComplex()
   {
   }
   /*
    * returns true if o is a complex number with imaginary part > 0 ?
    * @see HComplex
    * @see HDoubleComplex
    */
    public boolean evalArg1(HObject o) {
        return ((o instanceof HComplex) || (o instanceof HDoubleComplex));
    }
}
