package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EIsReal extends EB1ObjectArg {
   public EIsReal()
   {
   }
   /*
    * return true if o is a real number ? (e.g. instanceof HDouble, HInteger, HFraction)
    * @see HSignedNumber
    */
    public boolean evalArg1(HObject o) {
        return (o instanceof HSignedNumber);
    }
}
