/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.combinatoric.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

import org.kaffe.java.util.*;

import java.net.URL;
import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;


public class EKPartitions  implements FunctionEvaluator
{
   public EKPartitions()
   {
   }
   public HObject evaluate(HFunction fun)
   {
      if ( (fun.size() == 2)&&
           (fun.get(0) instanceof HFunction)  &&
           (fun.get(1) instanceof HInteger) )
      {
        HFunction f = (HFunction) fun.get(0);
        int n = f.size();
        int k = ((HInteger) fun.get(1)).intValue();
        if (k>n)
        {
          return null;
        }
        HFunction result = new HFunction( f.head() );
        HFunction temp;
        HFunction temp1;
        KPartitions comb = new KPartitions(n, k);
        int j[];
        int low, high;
        while( (j = (int[])comb.nextElement()) != null)
        {
          temp = new HFunction( f.head() );


          // print the KPartitions:
            for (int i=0; i<k; i++) {
              low = j[i];
              if (k-1==i) {
                high = n;
              }
              else {
                high = j[i+1];
              }
              temp1 = new HFunction( f.head() );
              for (int m=low; m<high; m++) {
                temp1.add( f.get(m) );
                //System.out.print(f.get(m).toString());
              }
              temp.add(temp1);
           //   System.out.print(" ");
            }


          result.add( temp );
        }
        return result;
      }
      return null;
   }

}
