package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class ELCMP implements FunctionEvaluator
{
    public ELCMP()
    {
    }
    public HObject evaluate(HFunction vect) {
			if (vect.size() == 3) {
        HPolynomial p = new HPolynomial(vect.get(0), vect.get(2));
        HPolynomial q = new HPolynomial(vect.get(1), vect.get(2));
 			  if (q.isNull()) {
					return null;
				}
   			return p.lcm(q).toFunction( );
			}

			return null;
		}    /*
		public HObject evaluate(HFunction vect) {
			if (vect.size() == 3) {
				HFunction	p = new HFunction(C.List);
				HFunction	q = new HFunction(C.List);

				if (HFunction.polyList(vect.get(0), vect.get(2), p) &&
            HFunction.polyList(vect.get(1), vect.get(2), q)) {
					return lcm(p, q).pInvConvert(vect.get(2));
				}
			}

			return null;
		}      */

}

