package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class ELevel implements FunctionEvaluator
{
   public ELevel()
   {
   }
   /**
    * Method declaration
    *
    *
    * @param vect
    *
    * @return
    *
    * @see
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 2)
      {
         HLevel lev = new HLevel(vect.get(1));

         if (vect.get(1) instanceof HFunction)
         {
            HArrayList       arr = new HArrayList();

            ((HFunction) vect.get(0)).level(arr, 0, lev);

            return C.List.body(arr);
         }

         if (lev.includes(-1, 1))
         {
            return C.List.f(vect.get(0));
         }
      }

      return null;
   }

}