package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EMax implements FunctionEvaluator
{
   public EMax()
   {
   }
   /**
    * Method declaration
    * @param fun
    * @return
    * @see
    */
   public HObject evaluate(HFunction fun)
   {
      if (fun.size() != 0)
      {
         HObject        max = fun.get(0);
         HObject        b;
         HFunction      f = C.Max.f();

         for (int i = 1; i < fun.size(); i++)
         {
            b = C.EV(C.Less.f(max, fun.get(i)));

            if (b.equals(C.True))
            {
               max = fun.get(i);
            }
            else
            {
               if (!b.equals(C.False))
               {
                  f.add(fun.get(i));
               }
            }
         }

         if (f.size() != 0)
         {

            // f.pushFront(max);
            f.add(0, max);

            if (((HFunction) f).equals((Object) fun))
            {
               return null;
            }

            return f;
         }
         else
         {
            return max;
         }
      }

      return null;
   }

}
