package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EModP implements FunctionEvaluator {
    public EModP()
    {
    }
    public HObject evaluate(HFunction vect) {
			if (vect.size() == 3) {
        HPolynomial p = new HPolynomial(vect.get(0), vect.get(2));
        HPolynomial q = new HPolynomial(vect.get(1), vect.get(2));
 			  if (q.isNull()) {
					return null;
				}
   			return p.mod(q).toFunction( );
			}

			return null;
		}

}
