package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EPrint implements FunctionEvaluator
{
   public EPrint()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() > 0)
      {
         for (int i = 0; i < vect.size(); i++)
         {
            C.resultOut.append(vect.get(i).toString());
         }

         C.resultOut.append("\n");

         return C.Null;
      }

      return null;
   }

}