package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class ESign extends E1Arg
{
   public ESign()
   {
   }
   /**
    * Method Declaration.
    * @param o
    * @return
    * @see
    */
   public HObject e1ObjArg(HObject o)
   {
      if (o instanceof HSignedNumber)
      {
         int    i = ((HSignedNumber) o).signum();

         if (i == 0)
         {
            i = 1;
         }

         return HInteger.valueOf(i);
      }

      return null;
   }

}
