package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.mapping.*;
import com.hartmath.lib.*;

public class ESinh extends E1Arg
{
/*
//Sinh:
Sinh(x_IsNumber):=Check(SignumCmp(x)<0, -Sinh(-x));
Sinh(x_IsNumber*y_):=Check(SignumCmp(x)<0, -Sinh(-x*y));
Sinh(0)=0;
Sinh(Infinity)=Infinity;
Sinh(I)=I*Sin(1);
 */
   final static long larr[] =
   {6150318750338269672L,2535335319515517268L,-1673559777641146798L,4595897385004127826L,4558179535699137034L,5924856209907012159L,-4084388475798667321L
,-1664271036669573434L,5931048664650555917L,5931048664650502719L};

   final static byte barr[] =
   {34, 12, 81, 85, -59, };

   static boolean first = true;
   public ESinh()
   {
     if (first) {
        first = false;
        C.EV( InitRules.init(larr, barr) );
     }
   }
   public HObject e1DblArg(HDouble dbl)
   {
     return dbl.sinh();
   }
   public HObject e1DblComArg(HDoubleComplex d)
   {
     return d.sinh();
   }

}




