package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EStandardDeviation extends E1Arg {
  public EStandardDeviation()
  {
  }
      public HObject e1FunArg(HFunction lst) {
	      if (lst.isList()&&lst.size()>0) {
		      HInteger v = HInteger.valueOf(lst.size());
          HFunction sum = C.Add.f();
          HObject arithMean = new EArithmeticMean().e1FunArg(lst);
          if (arithMean==null) { return null; }
          for (int i=0; i<lst.size(); i++ )
          {
            sum.add( C.Pow.f( C.Add.f(arithMean, C.Multiply.f(C.CN1, lst.get(i))), C.C2) );
          }
          return C.Pow.f( C.Multiply.f(sum, C.Pow.f(v, C.CN1)), C.C1D2 );
        }
        return null;
      }
}

