package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.mapping.*;
import com.hartmath.lib.*;

public class ETanh extends E1Arg
{
/*
//Tanh:
Tanh(x_IsNumber):=Check(SignumCmp(x)<0, -Tanh(-x));
Tanh(x_IsNumber*y_):=Check(SignumCmp(x)<0, -Tanh(-x*y));
Tanh(0)=0;
Tanh(Infinity)=1;
Tanh(I)=I*Tan(1);
 */
   final static long larr[] =
   {6150318750338925032L,2535335319515517268L,-1673559777641144238L,4595897385004130386L,4558179535699137034L,5924856209907012159L,-4084377480682389561L
,-1664271036668918074L,5931048707600270674L,5715455101461741346L};

   final static byte barr[] =
   {12, 81, 95, -59, };

   static boolean first = true;
   public ETanh()
   {
     if (first) {
        first = false;
        C.EV( InitRules.init(larr, barr) );
     }
   }

   public HObject e1DblArg(HDouble dbl)
   {
     return dbl.tanh();
   }
   public HObject e1DblComArg(HDoubleComplex d)
   {
     return d.tanh();
   }

}




