package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class ETiming implements FunctionEvaluator
{
   public ETiming()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 1)
      {
         long   begin = System.currentTimeMillis();

         C.EV(vect.get(0));

         return HInteger.valueOf(System.currentTimeMillis() - begin);
      }

      return null;
   }

} 