package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

import java.io.*;
import java.net.*;

public class EToLowerCaseStr implements FunctionEvaluator
{
   public EToLowerCaseStr()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if ((vect.size() == 1) && (vect.get(0) instanceof HString))
      {
         return new HString(vect.get(0).toString().toLowerCase());
      }

      return null;
   }

}

