/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

import org.kaffe.java.util.*;

import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;

/**
 * Class declaration
 * @author
 * @version %I%, %G%
 */
public class ETogether extends E1Arg {
    public ETogether()
    {
    }
    /**
     * Method declaration
     * @param o
     * @return
     * @see
     */
    public HObject e1ObjArg(HObject o) {
        if (o instanceof HFunction && o.head().equals(C.Add)) {
            HFunction f = (HFunction)o;
            if (f.size() <= 1) {
                return f;
            }
            HFunction ni;
            HObject temp;
            HFunction numer = new HFunction(C.Add, f.size());
            HFunction denom = new HFunction(C.Multiply, f.size());
            for (int i = 0; i < f.size(); i++) {
                numer.set(i, C.EV(C.Numerator.f(f.get(i))));
                denom.set(i, C.EV(C.Denominator.f(f.get(i))));
            }
            for (int i = 0; i < f.size(); i++) {
                ni = C.Multiply.f(numer.get(i));
                for (int j = 0; j < f.size(); j++) {
                    if (i == j) {
                        continue;
                    }
                    temp = denom.get(j);
                    if (!temp.equals(C.C1)) {
                        ni.add(temp);
                    }
                }
                numer.set(i, ni);
            }
            int i = 0;
            while (denom.size() > i) {
                if (denom.get(i).equals(C.C1)) {
                    denom.remove(i);
                    continue;
                }
                i++;
            }
            if (denom.size() == 0) {
                return numer;
            }
            return C.Multiply.f(numer, C.Pow.f(denom, C.CN1));
        }
        return o;
    }
}
