package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class ETrunc extends E1Arg
{
/*
//Trunc:
Trunc(Pi)=3;
Trunc(E)=2;
Trunc(x_IsNumber*y_):=Check(SignumCmp(x)<0, -Trunc(-x*y));
*/
   final static long larr[] =
   {6006203553673519637L,-4372345077198879548L,5931611684132045288L,2535470867477051729L,6118358150342463846L};

   final static byte barr[] =
   {82, 63, 82, 63, -57, -24, -25, };
  
   static boolean first = true;
   public ETrunc()
   {
     if (first) {
        first = false;
        C.EV( InitRules.init(larr, barr) );
     }
   }
   /**
    * Method Declaration.
    * @param o
    * @return
    * @see
    */
   public HObject e1ObjArg(HObject o)
   {
      if (o instanceof HSignedNumber)
      {
         if (((HSignedNumber) o).isNegative())
         {
            return ((HSignedNumber) o).ceil();
         }
         else
         {
            return ((HSignedNumber) o).floor();
         }
      }

      return null;
   }

}

