/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/
package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

import org.kaffe.java.util.HashSet;

import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;

public class EUnion implements FunctionEvaluator
{
   public EUnion()
   {
   }
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() >= 2)
      {
         if (!(vect.get(0) instanceof HFunction))
         {
            return null;
         }

         HashSet        set0 = new HashSet();
         HFunction      f = (HFunction) vect.get(0);
         HFunction      result = C.List.f();

         for (int i = 0; i < f.size(); i++)
         {
            set0.add(f.get(i));
         }

         HFunction      lst;

         for (int i = 1; i < vect.size(); i++)
         {
            if (vect.get(i) instanceof HFunction)
            {
               lst = (HFunction) vect.get(i);

               for (int j = 0; j < lst.size(); j++)
               {
                  set0.add(lst.get(j));
               }

            }
            else
            {
               return null;
            }
         }

         Object[] e = set0.toArray();

         for (int i=0;i<e.length;i++) {
            result.add( (HObject)e[i] );
         }

         result.sort();

         return result;
      }

      return null;
   }

}

