/*--- formatted by Jindent 2.0b2, (www.c-lab.de/~jindent) ---*/
package com.hartmath.lib;

import com.hartmath.expression.*;

import java.lang.*;

// import java.util.Enumeration;
// import com.objectspace.jgl.*;
// import java.awt.*;

/**
 * Class Declaration.
 * 
 * 
 * @see
 * 
 * @author
 * @version   %I%, %G%
 */
public class HLevel {
	int	from;
	int	to;

	/**
	 * Class Constructor.
	 * 
	 * 
	 * @param i
	 * 
	 * @see
	 */
	public HLevel(int i) {
		from = to = i;
			//{{INIT_CONTROLS
		//}}
}

	/**
	 * Class Constructor.
	 * 
	 *
	 * @param f
	 * @param t
	 * 
	 * @see
	 */
	public HLevel(int t, int f) {
		from = f;
		to = t;
	}

	/**
	 * Class Constructor.
	 * 
	 * 
	 * @param obj
	 * 
	 * @see
	 */
	public HLevel(HObject obj) {
		from = to = 0;

		if (obj instanceof HInteger) {
			HInteger i = (HInteger) obj;

			if (i.isNegative()) {
				from = i.intValue();
				to = 0;
			} else {
				to = i.intValue();
				from = 0;
			}
		}
		if (obj.isList()) {
			HFunction	lst = (HFunction) obj;

			if (lst.size() == 1) {
				if (lst.get(0) instanceof HInteger) {
					from = ((HInteger) lst.get(0)).intValue();
				} else {
					if (lst.get(0).equals(C.Infinity)) {
						from = Integer.MAX_VALUE;
					} else {
						if (lst.get(0).equals(C.Multiply.f(C.CN1, C.Infinity))) {
							from = Integer.MIN_VALUE;
						}
					}
				}

				to = from;
			} else {
				if (lst.size() == 2) {
					if (lst.get(0) instanceof HInteger 
							  && lst.get(1) instanceof HInteger) {
						from = ((HInteger) lst.get(0)).intValue();
						to   = ((HInteger) lst.get(1)).intValue();
					} else {
						if (lst.get(0) instanceof HInteger) {
							from = ((HInteger) lst.get(0)).intValue();
						} else {
							if (lst.get(0).equals(C.Infinity)) {
								from = Integer.MAX_VALUE;
							} else {
								if (lst.get(0).equals(C.Multiply.f(C.CN1,
																			 C.Infinity))) {
									from = Integer.MIN_VALUE;
								}
							}
						}
						if (lst.get(1) instanceof HInteger) {
							to = ((HInteger) lst.get(1)).intValue();
						} else {
							if (lst.get(1).equals(C.Infinity)) {
								to = Integer.MAX_VALUE;
							} else {
								if (lst.get(1).equals(C.Multiply.f(C.CN1,
																			 C.Infinity))) {
									to = Integer.MIN_VALUE;
								}
							}
						}
					}
				}
			}
		}
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public int from() {
		return from;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public int to() {
		return to;
	}

	/**
	 * test if this range includes the specified value
	 */
	public boolean includes(int negi, int posi) {
    if (to<from) {
      return (from <= posi && to >= negi);
    } 
		return ( (from <= posi && to >= posi)||
             (from <= negi && to >= negi) );
	}

	//{{DECLARE_CONTROLS
	//}}
}



/*--- formatting done in "Sun Java Convention" style on 08-02-1999 ---*/
