/*--- formatted by Jindent 2.0b2, (www.c-lab.de/~jindent) ---*/
package com.hartmath.expression;

import java.lang.*;

/**
 * Interface that represents a rational number (e.g. HInteger or HFraction)
 * 
 * 
 * @see HInteger
 * @see HFraction
 * 
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public interface HRational extends HSignedNumber {

	// abstract public boolean isPositive();
	// abstract public boolean isNegative();
	// abstract public boolean isNonNegative();

	/**
	 * returns the numerator of a number
	 */
	abstract public HInteger numer();

	/**
	 * returns the denominator of a number
	 */
	abstract public HInteger denom();
}



/*--- formatting done in "Sun Java Convention" style on 06-18-1999 ---*/

