package com.hartmath.combinatoric;

import com.hartmath.expression.*;
import com.hartmath.lib.*;

import java.util.*;

public class KPartitions {

  final int n;
  final int k;
  int j[];
  public KPartitions(int length, int parts)
  {
    n = length;
    k = parts;
    j = new int[parts];
    j[0] = -1;
  }
              /*
  public boolean hasMoreElements()
  {
    int i;
      if (j[0] < 0)
      {
         return true;
      }
      else
      {
         for (i = k - 1; i >= 0 && j[i] >= n - k + i; --i) {}
         if (i >= 0)
         {
           //--- begin: insert
            if (i==0)
            {
              return false;
            }
            //--- end
            return true;
         }
         else
         {
            return false;
         }
      }
  }
                */
  public Object nextElement()
  {
      int i;
      if (j[0] < 0)
      {
         for (i = 0; i < k; ++i)
         {
            j[i] = i;
         }

         return j;
      }
      else
      {

         for (i = k - 1; i >= 0 && j[i] >= n - k + i; --i) {}

         if (i >= 0)
         {
            //--- begin: insert
            if (i==0)
            {
              return null;
            }
            //--- end
            j[i]++;

            int m;

            for (m = i + 1; m < k; ++m)
            {
               j[m] = j[m - 1] + 1;
            }

            return j;
         }
         else
         {
            return null;
         }
      }
  }
               /*
  public static void main(String arg[]) throws Exception
   {

      final int parts = 4;

      HSymbol a = new HSymbol("a");
      HSymbol b = new HSymbol("b");
      HSymbol c = new HSymbol("b");
      HSymbol d = new HSymbol("d");
      HFunction f = C.List.f(a,b,c,d);
      f.add(d);
      int len = f.size();
      KPermutations perm = new KPermutations(f, len);
      int start[]={1,2,3,4,5,6,7,8,9};
      int m[];
      int low, high;
      int temp;

      m = new int[len];
      int p[];
      while((p = (int[])perm.nextElement())!=null){

        for (int i=0; i<len;i++) {
          m[i]=start[p[i]];
        }
        KPartitions comb = new KPartitions(len, parts);

        while(comb.hasMoreElements()){
          int j[] = (int[])comb.nextElement();
          next: {
            // check if permutation is valid:
            for (int i=0; i<parts; i++) {
              low = j[i];
              if (parts-1==i) {
                high = len-1;
              }
              else {
                high = j[i+1]-1;
              }
              if (high==low) {
                continue;
              }
              for (int k=low; k<high; k++) {
                if (m[k]>m[k+1]) {
                  break next;
                }
              }

            }
            // print the KPartitions:
            for (int i=0; i<parts; i++) {
              low = j[i];
              if (parts-1==i) {
                high = len;
              }
              else {
                high = j[i+1];
              }
              for (int k=low; k<high; k++) {
                System.out.print(m[k]);
              }
              System.out.print(" ");
            }
            System.out.print(" | ");

          }
        }
      //  System.out.println("nextperm: ");
      }
      System.in.read();
      System.exit(0);
   }         */
   public static void main(String arg[]) throws Exception
   {

      final int parts = 3;

      HSymbol a = new HSymbol("a");
      HSymbol b = new HSymbol("b");
      HSymbol c = new HSymbol("b");
      HSymbol d = new HSymbol("d");
      HFunction f = C.List.f(a,b,c,d);
      f.add(d);
      f.add(d);
      int len = f.size();
      int m[];
      int low, high;
      int temp;

      m = new int[len];
      int p[];

        KPartitions comb = new KPartitions(len, parts);
        int j[];
        //while(comb.hasMoreElements()){
        while ((j= (int[])comb.nextElement())!=null) {
            // print the KPartitions:
            for (int i=0; i<parts; i++) {
              low = j[i];
              if (parts-1==i) {
                high = len;
              }
              else {
                high = j[i+1];
              }
              for (int k=low; k<high; k++) {
                System.out.print(f.get(k).toString());
              }
              System.out.print(" ");
            }
            System.out.print(" | ");
          }
      System.in.read();
      System.exit(0);
   }
}