package com.hartmath.combinatoric;

import com.hartmath.expression.*;
import com.hartmath.lib.*;

import java.util.*;

public class NumberPartitions {

  final int n;
  int i, j, k;
  int x[];
  public NumberPartitions(int num)
  {
    n = num;
    x = new int[num];
    for (int i=0;i<num;i++)
    {
      x[i]=0;
    }
  }

  public Object nextElement()
  {
    int l;
    if ( i== -1) {
      return null;
    }
    if (! (x[0]==0) )
    {
     if (x[k]==1)
      {
        x[k]=0;
      }
     while (true)
     {
       l=k-i;
       k=i;
       x[i]=x[i]-1;
       while (x[k]<=l)
       {
         l = l-x[k++];
         x[k] = x[k-1];
       }
       if (k!=n-1)
       {
         x[++k]=l+1;
         if (x[i]!=1)
       {
         i = k;
       }
       if( x[i]==1 )
       {
         i--;
       }
        }
       else {
         k++;
         if (x[i]!=1)
       {
         i = k;
       }
       if( x[i]==1 )
       {
         i--;
       }
       continue;
      }

      return x;
     }
    }
    else
    {
      x[0] = n;
      k = 0;
      i = 0;
    }
    return x;
  }
  public static void main(String arg[]) throws Exception
   {
      int len = 5;
      try {
      NumberPartitions np = new NumberPartitions(len);
      int j[];
      while( (j = (int[])np.nextElement()) != null ){
        for (int k=0; k<j.length; k++) {
            System.out.print(Integer.toString(j[k]));
          }
        System.out.print(" ");
      }
      }
      catch (Throwable se)
      {
        se.printStackTrace();
      }
      System.in.read();
      System.exit(0);
   }
}