/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.awt;

import java.awt.*;
import java.awt.event.*;

/**
 */
public class PFrame extends Frame implements ActionListener {
 //   public MenuBar     menuBar = new MenuBar();
 //   public Menu	       fileMenu = new Menu("File");
 //   public MenuItem    closeItem =
//	new MenuItem("Close", new MenuShortcut(KeyEvent.VK_E));
//    public Menu	       toolMenu = new Menu("Tools");
//    public MenuItem    aboutItem =
//	new MenuItem("About..", new MenuShortcut(KeyEvent.VK_A));
//    public AboutDialog aboutDialog;
    static final int   BORDER_WIDTH = 5;
    static final int   TITLE_HEIGHT = 25;
    final boolean subWindow;

    /**
     * Constructor declaration
     *
     *
     * @see
     */
    public PFrame(boolean subWin) {
      super("");
      subWindow = subWin;
    }

    /**
     * Constructor declaration
     *
     *
     * @param title
     *
     * @see
     */
    public PFrame(String title) {
	super(title);
  subWindow = false;

	WindowListener wl = new WinClose(this);

	/*
	 * WindowListener wl = new WindowAdapter()
	 * {
	 * public void windowClosing(WindowEvent we)
	 * {
	 * shutDown();
	 * }
	 * };
	 */
	addWindowListener(wl);
 //	fileMenu.add(closeItem);
	//closeItem.addActionListener(this);
	//toolMenu.add(aboutItem);
	//aboutItem.addActionListener(this);

	//aboutDialog = new AboutDialog(this);

 //	menuBar.add(fileMenu);
	//menuBar.add(toolMenu);
 //	setMenuBar(menuBar);

	Dimension screenSize = getToolkit().getScreenSize();

	if (screenSize.width > 640) {
   //   C.xSize = 640;
   //   C.ySize = 480;
	    setSize(640, 480);
   // test 1/2 VGA
   //   C.ySize = 240;
   //   setSize(640, 240);
	} else {
	    setBounds(-BORDER_WIDTH, -TITLE_HEIGHT, 
		      screenSize.width + 2 * BORDER_WIDTH, 
		      screenSize.height + TITLE_HEIGHT + BORDER_WIDTH);
	}
    }

    /**
     * A sub class of PFrame that implements actionPerformed should call super.actionPeformed(ActionEvent e), to ensure
     * that the actions handled by PFrame are not ignored
     */
    public void actionPerformed(ActionEvent ae) {
 //	if (ae.getSource() == closeItem) {
//	    shutDown();
//	} else if (ae.getSource() == aboutItem) {
//	    aboutDialog.setVisible(true);
//	}
    }

    /**
     * Override shutDown() for different or additional behaviour
     */
    public void shutDown() {
      if (subWindow) {
        dispose();
      }
      else {
    	  System.exit(0);
      }
    }

}


/**
 * Class declaration
 *
 *
 * @author
 * @version %I%, %G%
 */
class WinClose extends WindowAdapter {
    PFrame frame;
    public WinClose(PFrame f) {
      frame = f;
    }
    /**
     * Method declaration
     *
     *
     * @param we
     *
     * @see
     */
    public void windowClosing(WindowEvent we) {
	    frame.shutDown();
    } 

}

/*--- formatting done in "Sun Java Convention" style on 08-09-1999 ---*/
