package com.hartmath.mapping;

import com.hartmath.expression.*;

public class Size2TypeXY implements UnaryPredicate
{
  private int x1;
  private int x2;

  public Size2TypeXY(int x, int y)
  {
    x1 = x;
    x2 = y;
  }
  /**
    * checks if the function has size()==1 and
    * and the first argument has the given hierarchy()
    */
	public boolean execute(HFunction f)
  {
    return (f.size()==2)&&
           ((f.get(0).hierarchy()&x1)==x1)&&
           ((f.get(1).hierarchy()&x2)==x2);
  }
}
