/*--- formatted by Jindent 2.0b2, (www.c-lab.de/~jindent) ---*/

package com.hartmath.lib;

import com.hartmath.util.*;
import com.hartmath.lib.*;
import com.hartmath.expression.*;

import java.lang.*;

/**
 * Evaluates a given input string
 * 
 * @author Klaus Hartlage (khartlage@t-online.de)
 */
public class StringEvaluator {
	String			str;
 //	int				count;
	ResultOutput	edit2;

	/**
	 * Class Constructor.
	 * 
	 * 
	 * @param s
	 * @param cnt
	 * @param ed
	 *
	 * @see
	 */
	public StringEvaluator(String s, ResultOutput ed) {
		str = s;
	//	count = cnt;
		edit2 = ed;
  }

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @see
	 */

  public boolean evaluate() {
      if (C.initialized == false)
      {
         return false;
      }
      ContextThread ctThread = new ContextThread();
      try
      {
        ctThread.setInput(str);
        ctThread.start();
        if (C.timeConstrained > 2000) {
      // minimum == 2 seconds:
          ctThread.join(C.timeConstrained);
        }
        else
        {
          ctThread.join(0);
        }
      }
      catch (InterruptedException se)
      {
         edit2.appendLine("Unknown Exception occured: " + se.getMessage());
         if (C.DEBUG)
         {
            se.printStackTrace();
         }
      }
      edit2.append(ctThread.getOutput( ));
      return true;
  }
}



/*--- formatting done in "Sun Java Convention" style on 06-18-1999 ---*/

