/*--- formatted by Jindent 2.0b2, (www.c-lab.de/~jindent) ---*/

package com.hartmath.mapping;

import com.hartmath.expression.*;

/**
 * Interface that represents a function evaluation object.
 * FunctionEvaluator is used as an interface for built-in functions,
 * which are associated with a symbol.
 * 
 * @see HSymbol
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 * @version   %I%, %G%
 */
public class ConstantEvaluator extends ConstantNumericEvaluator {
  HObject symbolicValue;
  public ConstantEvaluator(HObject nVal, HObject sVal)
	{
		super( nVal );
		symbolicValue = sVal;
	}
   
  public HObject getSymbolicValue()
	{
		return symbolicValue;
	}	 
}



/*--- formatting done in "Sun Java Convention" style on 06-18-1999 ---*/