package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EAbs extends E1Arg
{
/*
//Abs
Abs(Pi)=Pi;
Abs(E)=E;
Abs(-Pi)=Pi;
Abs(-E)=E;
Abs(x_IsNumber*y_):=Abs(x)*Abs(y);
Abs(y^x_IsReal):=Abs(y)^x;
*/
   final static long larr[] =
   {4611686018530368082L,5715349548493313362L,5715349548208096338L,5715349755367203349L,2455959672415343167L,-4097708166805827247L,23150500390318029L
   ,5926544698982334695L,5931611246045816641L,-1719474204282126105L};

   final static byte barr[] =
   {-24, };
  
   static boolean first = true;
   public EAbs()
   {
     if (first) {
        first = false;
        C.EV( InitRules.init(larr, barr) );
     }
   }
   /**
    * Method Declaration.
    * @param o
    * @return
    * @see
    */
   public HObject e1ObjArg(HObject o)
   {
      if (o instanceof HNumber)
      {
         return ((HNumber) o).abs();
      }

      return null;
   }

}
