/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

import org.kaffe.java.util.*;

import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;

/**
 * Floating point functions with 1 argument of type HDouble or HDoubleComplex
 * 
 * @see FunctionEvaluator
 * 
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public class EAiryAi extends E1Arg
{
/*
// AiryAi
AiryAi(0)=1/3*3^(1/3)*Gamma(2/3);
*/
   final static long larr[] =
   {5931027541430518121L,8248696111733145728L,-4155907940181228609L,4476578052278676845L,6989586623828263427L};
   final static byte barr[] =
   {};
  
   static boolean first = true;
   public EAiryAi()
   {
     if (first) {
        first = false;
        C.EV( InitRules.init(larr, barr) );
     }
   }
   public HObject e1DblArg(HDouble dbl)
   {
      return new HDouble(HDoubleSpecial.airy(dbl.doubleValue()));
   }
}

