package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EAnd extends E2Arg implements FunctionOpEvaluator
{
   public EAnd()
   {
   }
   /**
    * Method Declaration.
    * @param o0
    * @param o1
    * @return
    * @see
    */
   public HObject e2ObjArg(HObject o0, HObject o1)
   {
      if (o0.equals(C.False) || o1.equals(C.False))
      {
         return C.False;
      }

      if (o0.equals(C.True) && o1.equals(C.True))
      {
         return C.True;
      }

      return null;
   }

   /**
    * Method Declaration.
    * @param fun
    * @return
    * @see
    */
   public String toOpString(HFunction fun)
   {
      return E2Arg.operatorString(fun, "&&", 100);
   }

   /**
    * Method Declaration.
    * @return
    * @see
    */
   public int precedence()
   {
      return 100;
   }

}


