package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

/**
 * Catalan number
 */
public class ECatalanNumber extends E1Arg {
    public ECatalanNumber()
    {
    }
		public HObject e1ObjArg(HObject o) {
			if (C.IsNegative.f(o).equals(C.True)) {
				return C.C0;
			}
			if (o instanceof HInteger) {
				HInteger temp = (HInteger) o;

				if (temp.isZero()) {
					return C.C0;
				}

				HInteger i = C.C1;
				HInteger c = C.C1;
				HInteger temp0 = temp.subtract(C.C1);
				HInteger temp1 = temp0.shiftLeft(1).add(C.C1);

				while (i.isLessEqual(temp0)) {
					c = c.multiply(temp1.subtract(i)).divide(i);
					i = i.add(C.C1);
				}

				return c.divide(temp);
			}

			return null;
		}

}
