package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class ECatch implements FunctionEvaluator
{
   public ECatch()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 1)
      {
         try
         {
            return C.EV(vect.get(0));
         }
         catch (HThrowException e)
         {
            return e.why();
         }
      }

      return C.Null;
   }

}
