package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class ECeil extends E1Arg
{
/*
//Ceil:
Ceil(-Pi)=-3;
Ceil(-E)=-2;
Ceil(Pi)=4;
Ceil(E)=3;
Ceil(x_IsInteger+y_):=x+Ceil(y);
*/
   final static long larr[] =
   {6150318741743292991L,-4097688756540190455L,5926674583565914703L,5839235868712390481L,658093732495708425L,5909921076295093586L};

   final static byte barr[] =
   {4, -24, 81, 9, -25, };
  
   static boolean first = true;
   public ECeil()
   {
     if (first) {
        first = false;
        C.EV( InitRules.init(larr, barr) );
     }
   }
   /**
    * Method Declaration.
    * @param o
    * @return
    * @see
    */
   public HObject e1ObjArg(HObject o)
   {
      if (o instanceof HSignedNumber)
      {
         return ((HSignedNumber) o).ceil();
      }

      return null;
   }

}

