package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EDefinition implements FunctionEvaluator
{
   public EDefinition()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if ((vect.size() == 1) && (vect.get(0) instanceof HSymbol))
      {
         C.resultOut.append(((HSymbol) vect.get(0)).getDefinition());

         return C.Null;
      }

      return null;
   }
}

