package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

import java.math.*;
/**
 * Class Declaration.
 * @see
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 * @version   %I%, %G%
 */
public class EFactorial extends E1Arg {
  public EFactorial()
  {
  }
  public HObject e1IntArg(HInteger i) {
    return factorial(i);
  }
  /**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public HInteger factorial(HInteger hi) {
		BigInteger  result = new BigInteger(HInteger.I1);
    BigInteger biggi = hi.bigIntegerValue();
		if (biggi.compareTo(HInteger.B0) == -1) {
			result = new BigInteger(HInteger.IN1);

			for (BigInteger i = new BigInteger(HInteger.IN2); i.compareTo(biggi) >= 0;
					  i = i.add(HInteger.BN1)) {
				result = result.multiply(i);
			}
		} else {
			for (BigInteger i = new BigInteger(HInteger.I2); i.compareTo(biggi) <= 0;
					  i = i.add(HInteger.B1)) {
				result = result.multiply(i);
			}
		}

		HInteger i = new HInteger(result);

		// i.biggi = result;

		return i;
	}
}

