package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EFloor extends E1Arg
{
/*
//Floor:
Floor(-Pi)=-4;
Floor(-E)=-3;
Floor(Pi)=3;
Floor(E)=2;
Floor(x_IsInteger+y_):=x+Floor(y);
*/
   final static long larr[] =
   {6150318741744407103L,-4097688752245223142L,5926674583565980239L,5844020943333248849L,1883072835435450650L,5909921076295093586L};

   final static byte barr[] =
   {4, -24, 81, 26, -25, };
  
   static boolean first = true;
   public EFloor()
   {
     if (first) {
        first = false;
        C.EV( InitRules.init(larr, barr) );
     }
   }
   /**
    * Method Declaration.
    * @param o
    * @return
    * @see
    */
   public HObject e1ObjArg(HObject o)
   {
      if (o instanceof HSignedNumber)
      {
         return ((HSignedNumber) o).floor();
      }

      return null;
   }

}


