/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

import org.kaffe.java.util.*;

import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;

/**
 * Floating point functions with 1 argument of type HDouble or HDoubleComplex
 * 
 * @see FunctionEvaluator
 * 
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public class EGamma extends E1Arg
{
//Gamma(x_IsInteger):=If(x>0, Factorial(x-1), Throw(SingularityError,Gamma) );
   final static long larr[] =
   {5931590491383875425L,7885065175223533633L,-1719485195690565656L,-4156513141025880238L};
   final static byte barr[] =
   {97, 34, 22, 33, 0, 0, };
  
   static boolean first = true;
   public EGamma()
   {
     if (first) {
        first = false;
        C.EV( InitRules.init(larr, barr) );
     }
   }
   public HObject e1DblArg(HDouble dbl)
   {
      return new HDouble(HDoubleSpecial.gamma(dbl.doubleValue()));
   }
}

