package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;

public class EGetFileStr implements FunctionEvaluator
{
   public EGetFileStr()
   {
   }

   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if ((vect.size() == 1) && (vect.get(0) instanceof HString))
      {
         StringBuffer   buffer = new StringBuffer();

         try
         {
            BufferedReader      in = 
               new BufferedReader(new InputStreamReader(new FileInputStream(vect.get(0).toString())));

            while (in.ready())
            {
               buffer.append(in.readLine());

               if (in.ready())
               {
                  buffer.append("\n");
               }
            }
         }
         catch (Exception exc) {}

         return new HString(buffer);
      }

      return null;
   }

}
