package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EInsert implements FunctionEvaluator
{
   public EInsert()
   {
   }
   /**
    * Method declaration
    *
    *
    * @param vect
    *
    * @return
    *
    * @see
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 3 && vect.get(0) instanceof HFunction)
      {
         if (vect.get(2) instanceof HInteger || vect.get(2) instanceof HDouble)
         {
            int m = 0;

            if (vect.get(2) instanceof HInteger)
            {
               m = ((HInteger) vect.get(2)).intValue();
            }
            else
            {
               m = ((HDouble) vect.get(2)).intValue();
            }

            HFunction   f = (HFunction) ((HFunction) vect.get(0)).clone();

            //f.insert(m - 1, vect.get(1));
            f.add(m - 1, vect.get(1));
            return f;
         }
      }

      return null;
   }

}