package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EInverseMod implements FunctionEvaluator
{
   public EInverseMod()
   {
   }
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 2 && vect.get(0) instanceof HInteger 
          && vect.get(1) instanceof HInteger)
      {
         HInteger       i0 = (HInteger) vect.get(0);
         HInteger       i1 = (HInteger) vect.get(1);

         return i0.modInverse(i1);
      }

      return null;
   }

}

