package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EIsAtom extends EB1ObjectArg {
   public EIsAtom()
   {
   }
   /*
    * return true if o is an atomic object (e.g. no HFunction)
    * @see HFunction
    */
    public boolean evalArg1(HObject o) {
        return !(o instanceof HFunction);
    }
}
