package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EIsMatrix extends EB1ObjectArg {
    public EIsMatrix()
    {
    }
    /**
     * returns true if o is a matrix ?
     * @see HFunction
     */
    public boolean evalArg1(HObject o) {
        if (o instanceof HFunction) {
            return ((HFunction)o).isMatrix() != null;
        }
        return false;
    }
}
