package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EIsRational extends EB1ObjectArg {
   public EIsRational()
   {
   }
   /*
    * returns true if o is a rational number (e.g. instanceof HInteger, HFraction)
    * @see HRational
    */
    public boolean evalArg1(HObject o) {
        return (o instanceof HRational);
    }
}