package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EIsSame extends EB2Arg {
   public EIsSame()
   { 
   } 
   /*
    * returns true if o1 is equal to o0 ? 
    * @see EEqual
    */
    public boolean eBool2ObjArg(HObject o0, HObject o1) {
        if (C.EV(new HFunction(C.Equal, o0, o1)) == C.True) {
            return true;
        }
        return false;
    }
}