package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EIsVector extends EB1ObjectArg {
    public EIsVector()
    {
    }
    /**
     * returns true if o is a vector ?
     * @param o
     * @return
     * @see
     */
    public boolean evalArg1(HObject o) {
        if (o instanceof HFunction) {
            return ((HFunction)o).isVector() != null;
        }
        return false;
    }
}