/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.combinatoric.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

import org.kaffe.java.util.*;

import java.net.URL;
import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;


public class EKSubsets  implements FunctionEvaluator
{
   public EKSubsets()
   {
   }
   public HObject evaluate(HFunction fun)
   {
      if ( (fun.size() == 2)&&
           (fun.get(0) instanceof HFunction)  &&
           (fun.get(1) instanceof HInteger) )
      {
        HFunction f = (HFunction) fun.get(0);
        int n = f.size();
        int k = ((HInteger) fun.get(1)).intValue();
        if (k>n)
        {
          return null;
        }
        HFunction result = new HFunction( f.head() );
        HFunction temp;
        KSubsets comb = new KSubsets(n, k);
        int j[];
        while( (j = (int[])comb.nextElement()) != null)
        {
          temp = new HFunction( f.head() );
          for (int i=0; i<k; i++) {
            temp.add( f.get(j[i]) );
          }
          result.add( temp );
        }
        return result;
      }
      return null;
   }

}
