package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EMap implements FunctionEvaluator
{
   public EMap()
   {
   }
   /**
    * Method Declaration.
    * 
    * 
    * @param vect
    * 
    * @return
    * 
    * @see
    */
   public HObject evaluate(HFunction vect)
   {
      if ((vect.size() == 2) && vect.get(1) instanceof HFunction)
      {
         HFunction      f = (HFunction) vect.get(1);

         return f.map(vect.get(0));
      }

      if ((vect.size() == 3) && vect.get(1) instanceof HFunction)
      {
         HFunction      f = (HFunction) vect.get(1);
         HFunction      g = new HFunction(f.head());

         f.map(g, vect.get(0), 0, new HLevel(vect.get(2)));

         return g;
      }

      return null;
   }

}
