package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EMultiplyP implements FunctionEvaluator {
    public EMultiplyP()
    {
    }

		public HObject evaluate(HFunction vect) {
			if (vect.size() == 3) {
				HPolynomial	p = new HPolynomial(vect.get(0), vect.get(2));
				HPolynomial	q = new HPolynomial(vect.get(1), vect.get(2));
				return p.multiply(q).toFunction();
			}

			return null;
		}
}
