/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.combinatoric.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

import org.kaffe.java.util.*;

import java.net.URL;
import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;


public class ENumberPartitions  implements FunctionEvaluator
{
   public ENumberPartitions()
   {
   }
   public HObject evaluate(HFunction fun)
   {
      if ( (fun.size() == 1)&&
           (fun.get(0) instanceof HInteger) )
      {
        int n = ((HInteger) fun.get(0)).intValue();
        HFunction result = C.List.f();
        HFunction temp;
        NumberPartitions comb = new NumberPartitions(n);
        int j[];
        while( (j = (int[])comb.nextElement()) != null)
        {
          temp = C.List.f();
          for (int i=0; i<j.length; i++) {
            if ( j[i]!=0 ) {
              temp.add( HInteger.valueOf(j[i]) );
            }
          }
          result.add( temp );
        }
        return result;
      }
      return null;
   }

}
