/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

import org.kaffe.java.util.*;

import java.net.URL;
import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;


public class EPartition  implements FunctionEvaluator
{
   public EPartition()
   {
   }
   public HObject evaluate(HFunction fun)
   {
      if ((fun.size() >= 2) && (fun.size() <= 3) &&fun.get(0) instanceof HFunction)
      {
        if ( fun.get(1) instanceof HInteger )
        {
          HFunction f = (HFunction) fun.get(0);
          int n = ((HInteger) fun.get(1)).intValue();
          HFunction result = new HFunction( f.head() );
          HFunction temp;
          int i = n;
          int v = n;
          if ((fun.size() == 3) && fun.get(2) instanceof HInteger) {
            v = ((HInteger) fun.get(2)).intValue();
          }
          while (i <= f.size())
          {
            temp = new HFunction( f.head() );
            for (int j=i-n;j<i;j++)
            {
              temp.add( f.get(j) );
            }
            i += v;
            result.add( temp );
          }
          return result;
        }
      }
      return null;
   }

}
