/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;
import com.hartmath.combinatoric.*;

import org.kaffe.java.util.*;

import java.net.URL;
import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;

              /*
class Permutation {
  HArrayList x;
  int[] p;
  int[] d;
  int n;
  boolean end;

  public Permutation(HArrayList arr) {
    x =  (HArrayList) arr.clone();
    n = x.size();
    p = new int[n+1];
    d = new int[n+1];
    for (int j=0;j<n;j++) {
      p[j]=0;
      d[j]=1;
    }
    end = false;
  }

  public boolean hasNext() {
    return (! end);
  }

  public HArrayList nextPerm() {
     int k,m,sig;
     HObject h;
     k=0;
     m=1;
     sig=p[m]+d[m];
     p[m]=sig;
     while ( (sig==n-m+1) || (sig==0))
     {
       if(sig==0)
       {
         d[m]=1;
         k++;
       }
       else
       {
         d[m]=(-1);
       }
       if (m==(n-1)) {
         h=x.get(n-2);
         x.set(n-2,x.get(n-1));
         x.set(n-1,h);
         end = true;
         sig=1;
       }
       else
       {
         m++;
         sig=p[m]+d[m];
         p[m]=sig;
       }
     }
     if (! end)
     {
       h=x.get(k+sig-1);
       x.set(k+sig-1, x.get(k+sig));
       x.set(k+sig, h);
     }
     return (HArrayList)x.clone();
   }

}               */
public class EPermutations  implements FunctionEvaluator
{
   public EPermutations()
   {
   }
   public HObject evaluate(HFunction fun)
   {
      if ( (fun.size() >= 1) &&
           (fun.size() <= 2) &&
           fun.get(0) instanceof HFunction)
      {
         HFunction f = (HFunction) fun.get(0);
         HFunction result = new HFunction( f.head() );
         if (f.size()<=1) {
           if (f.size()==1) {
             result.add(f);
           }
           return result;
         }
         int k = f.size();
         if ( fun.size() == 2 )
         {
           if (! (fun.get(1) instanceof HInteger) )
           {
             return null;
           }
           k = ((HInteger) fun.get(1)).intValue();
           if (k>f.size())
           {
             return null;
           }
         }
         KPermutations perm = new KPermutations( f, k );
       //  while (perm.hasNext()) {
         int j[];
         HFunction temp;
         while( (j = (int[])perm.nextElement()) != null)
         {
           temp = new HFunction( f.head() );
           for (int i=0; i<k; i++)
           {
             temp.add( f.get(j[i]) );
           }
           result.add( temp ) ;
         }
         return result;
      }
      return null;
   }

}
