/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;
/**
 * Class Declaration.
 * 
 * 
 * @see
 * 
 * @author
 * @version   %I%, %G%
 */
public class EReplaceStr implements FunctionEvaluator
{
   public EReplaceStr()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if ((vect.size() == 3) && (vect.get(0) instanceof HString) 
          && (vect.get(1) instanceof HString) 
          && (vect.get(1).toString().length() == 1) 
          && (vect.get(2) instanceof HString) 
          && (vect.get(2).toString().length() == 1))
      {
         return new HString(vect.get(0).toString().replace(vect.get(1).toString().charAt(0), 
                                           vect.get(2).toString().charAt(0)));
      }

      return null;
   }

}
