package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EReturn implements FunctionEvaluator
{
   public EReturn()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() <= 1)
      {
         if (vect.size() == 1)
         {
            throw new HReturnException(vect.get(0));
         }

         throw new HReturnException();
      }

      return null;
   }

}
