package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class ESetAttributes implements FunctionEvaluator
{
   public ESetAttributes()
   {
   }
   /**
    * Method Declaration.
    * 
    * 
    * @param vect
    * 
    * @return
    * 
    * @see
    */
   public HObject evaluate(HFunction vect)
   {
      if ((vect.size() == 2) && vect.get(0) instanceof HSymbol)
      {
         HSymbol        sym = ((HSymbol) vect.get(0));

         if (vect.get(1) instanceof HSymbol)
         {
            if (((HSymbol) vect.get(1)) == C.Flat)
            {
               sym.setAttributes(HSymbol.FLAT);

               return C.Null;
            }

            if (((HSymbol) vect.get(1)) == C.Listable)
            {
               sym.setAttributes(HSymbol.LISTABLE);

               return C.Null;
            }

            if (((HSymbol) vect.get(1)) == C.OneIdentity)
            {
               sym.setAttributes(HSymbol.ONEIDENTITY);

               return C.Null;
            }

            if (((HSymbol) vect.get(1)) == C.Orderless)
            {
               sym.setAttributes(HSymbol.ORDERLESS);

               return C.Null;
            }

            if (((HSymbol) vect.get(1)) == C.HoldAll)
            {
               sym.setAttributes(HSymbol.HOLDALL);

               return C.Null;
            }

            if (((HSymbol) vect.get(1)) == C.HoldFirst)
            {
               sym.setAttributes(HSymbol.HOLDFIRST);

               return C.Null;
            }

            if (((HSymbol) vect.get(1)) == C.HoldRest)
            {
               sym.setAttributes(HSymbol.HOLDREST);

               return C.Null;
            }
         }
         else
         {
            if (vect.get(1).isList())
            {
               HFunction        lst = (HFunction) vect.get(1);

               for (int i = 0; i < lst.size(); i++)
               {
                  if (((HSymbol) lst.get(i)) == C.Flat)
                  {
                     sym.setAttributes(HSymbol.FLAT);
                  }

                  if (((HSymbol) lst.get(i)) == C.Listable)
                  {
                     sym.setAttributes(HSymbol.LISTABLE);
                  }

                  if (((HSymbol) lst.get(i)) == C.OneIdentity)
                  {
                     sym.setAttributes(HSymbol.ONEIDENTITY);
                  }

                  if (((HSymbol) lst.get(i)) == C.Orderless)
                  {
                     sym.setAttributes(HSymbol.ORDERLESS);
                  }

                  if (((HSymbol) lst.get(i)) == C.HoldAll)
                  {
                     sym.setAttributes(HSymbol.HOLDALL);
                  }

                  if (((HSymbol) lst.get(i)) == C.HoldFirst)
                  {
                     sym.setAttributes(HSymbol.HOLDFIRST);
                  }

                  if (((HSymbol) lst.get(i)) == C.HoldRest)
                  {
                     sym.setAttributes(HSymbol.HOLDREST);
                  }
               }        // end for

               return C.Null;
            }
         }
      }

      return null;
   }
}