/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

import org.kaffe.java.util.*;

import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;


/**
 * Class declaration
 * @author
 * @version %I%, %G%
 */
public class ETaylor implements FunctionEvaluator {
    public ETaylor()
    {
    }
    public HObject evaluate(HFunction vect) {
        if (vect.size() == 4 && vect.get(3) instanceof HInteger) {
            int count = ((HInteger)vect.get(3)).intValue();
            if (count < 0) {
                return null;
            }
            HFunction fadd = C.Add.f(C.EV(C.ReplaceAll.f(vect.get(0), C.Rule.f(vect.get(1), vect.get(2)))));
            HObject temp = vect.get(0);
            HObject factor = null;
            for (int i = 1; i <= count; i++) {
                temp = C.EV(C.D.f(temp, vect.get(1)));
                factor = C.EV(C.Multiply.f(C.Pow.f(C.Factorial.f(HInteger.valueOf(i)), C.CN1), C.Pow.f(C.Add.f(vect.get(1),
                    C.Multiply.f(C.CN1, vect.get(2))), HInteger.valueOf(i))));
                fadd.add(C.EV(C.Multiply.f(C.ReplaceAll.f(temp, C.Rule.f(vect.get(1), vect.get(2))), factor)));
            }
            return fadd;
        }
        return null;
    }
}

