package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

import java.io.*;
import java.net.*;

public class ETimeConstrained implements FunctionEvaluator
{
   public ETimeConstrained()
   {
   }
   public HObject evaluate(HFunction vect) {
     if ((vect.size() == 2)
         && (vect.get(1) instanceof HInteger || vect.get(1) instanceof HDouble)
         && ((HSignedNumber) vect.get(1)).isPositive())
     {
       int    m = 0;  
       if (vect.get(1) instanceof HInteger)  
       {  
          m = ((HInteger) vect.get(1)).intValue();
       }
       else
       {
          m = ((HDouble) vect.get(1)).intValue();  
       }
       m*=1000;
       //Context ct = ((ContextThread) Thread.currentThread()).getContext();
       ContextThread ctThread = new ContextThread(vect.get(0));
       try
       {
         ctThread.start();
         if (m >= 1000) {
       // minimum == 2 seconds:
           ctThread.join(m);
         }
         else
         {
           ctThread.join(1000);
         }
         HObject o = ctThread.getResult();
         return (o==null)?C.Interrupted : o;
       }
       catch (InterruptedException se)
       {
         return C.Interrupted;
       }
     }
     return null;
   }
}
