package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EXor extends E2Arg
{
   public EXor()
   {
   }
   /**
    * Method Declaration.
    * @param o0
    * @param o1
    * @return
    * @see
    */
   public HObject e2ObjArg(HObject o0, HObject o1)
   {
      if (o0.isNumber() || o1.isNumber())
      {
         return null;
      }

      if (o0.equals(o1))
      {
         return C.False;
      }

      if (o0.equals(C.False) && o1.equals(C.True))
      {
         return C.True;
      }

      if (o0.equals(C.True) && o1.equals(C.False))
      {
         return C.True;
      }

      return null;
   }

}
