package com.hartmath.awt;

import java.awt.*;

class GridPanel extends Panel
{
  GridBagLayout layout; 
  GridBagConstraints constraints;

  GridPanel()
  {
    layout = new GridBagLayout();
    setLayout(layout);
    constraints = new GridBagConstraints();
    constraints.insets = new Insets(2, 2, 2, 2);
    constraints.anchor = GridBagConstraints.NORTH;
  }



  void add(Component item, int gridx, int gridy)
  {
    constraints.gridx = gridx;
    constraints.gridy = gridy;
    layout.setConstraints(item, constraints);
    add(item);
  }
}

