/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

import com.hartmath.*;
import com.hartmath.util.*;
import com.hartmath.lib.*;
import com.hartmath.awt.*;
import com.hartmath.expression.*;

import java.lang.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

/**
 * HartMath applet class - implements the graphical user interface
 * 
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public class HMPsion extends HMPsionApplet
{
   /**
    * main must be called for standalone applications
    */
   public static void main(String args[])
   {
      main_args = args;

      HMPsion   applet = new HMPsion();

      applet.isStandalone = true;
      
      EFrame    frame = new EFrame(false);

      frame.setTitle("HartMath CAS");
      frame.add("Center", applet);

      // frame.addWindowListener(new WindowAdapter() {
      // public void windowClosing(WindowEvent e) {System.exit(0);}
      // });
      Dimension d = frame.getSize();

      applet.xSize = d.width;
      applet.ySize = d.height;

      applet.init();
      frame.initTextArea(applet.edit1, applet.edit2);
      applet.start();

      /*
       * frame.setSize(570, 240);
       * Dimension	d = Toolkit.getDefaultToolkit().getScreenSize();
       * frame.setLocation((d.width - frame.getSize().width) / 2,
       * (d.height - frame.getSize().height) / 2);
       */
      frame.setVisible(true);
   }

}       // end class HMPsion



