/*--- formatted by Jindent 2.0b2, (www.c-lab.de/~jindent) ---*/

package com.hartmath.lib;

import com.hartmath.expression.*;

import java.lang.*;

/**
 * special exception which can be caught by the hartmath Catch() function
 * 
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public class HThrowException extends RuntimeException {
	HFunction	f;

	/**
	 * Class Constructor.
	 * 
	 * 
	 * @param h classification of exception
	 * @param s function where the error occurs
	 *
	 * @see
	 */
	public HThrowException(HSymbol h, HSymbol s) {
		f = new HFunction(h, s);
			//{{INIT_CONTROLS
		//}}
}

	/**
	 * Class Constructor.
	 * 
	 * 
	 * @param h classification of exception
	 * @param s function where the error occurs
	 * @param a parameter for additional information
	 *
	 * @see
	 */
	public HThrowException(HSymbol h, HSymbol s, HObject a) {
		f = new HFunction(h, s, a);
	}

	/**
	 * Class Constructor.
	 * 
	 * 
	 * @param h classification of exception
	 * @param s function where the error occurs
	 * @param a parameter for additional information
	 * @param b parameter for additional information
	 *
	 * @see
	 */
	public HThrowException(HSymbol h, HSymbol s, HObject a, HObject b) {
		f = new HFunction(h, s, a, b);
	}

	/**
	 * Class Constructor.
	 * 
	 * 
	 * @param h classification of exception
	 * @param s function where the error occurs
	 * @param a parameter for additional information
	 * @param b parameter for additional information
	 * @param c parameter for additional information
	 *
	 * @see
	 */
	public HThrowException(HSymbol h, HSymbol s, HObject a, HObject b, 
								  HObject c) {
		f = new HFunction(h, s, a, b, c);
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public HFunction why() {
		return f;
	}

	//{{DECLARE_CONTROLS
	//}}
}



/*--- formatting done in "Sun Java Convention" style on 07-15-1999 ---*/

