package com.hartmath.JSci.chemistry.periodictable;


import com.hartmath.JSci.chemistry.Element;

/**
* A class representing rare earth metals.
* @version 1.5
* @author Mark Hale
*/
public class RareEarthMetal extends Element {
        /**
        * Constructs a rare earth metal.
        */
  
  public RareEarthMetal(String n, String s,
                          int an, int mn, double en, double cr, double ar,
                          double mp, double bp, double de, double sh,
                          double ec, double tc) {
    super(n, s, an, mn, en, cr, ar, mp, bp, de, sh, ec, tc);
  }
}

